//+------------------------------------------------------------------+
//|                                                  MA 2 colors.mq4 |
//|                     Copyright  *** onewithzachy *** 27 May 2012 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  *** onewithzachy *** 27 May 2012"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 Aqua
//--- input parameters
extern int  Fast_Period=5;
extern int  Slow_Period=20;
extern int  Crossing_Alert_On_Bar=0; // -1 no Alert, 0 = Alert on bar 0, 1 = Alert on bar 1, ...
//--- buffers
double Secondary_Fast[], Main_Fast[], Secondary_Slow[], Main_Slow[], Alert_State = 0.0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexBuffer(0, Main_Fast);
   SetIndexBuffer(1, Secondary_Fast);
   SetIndexBuffer(2, Main_Slow);
   SetIndexBuffer(3, Secondary_Slow);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 3);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 3);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 3);
   SetIndexStyle(3, DRAW_LINE, STYLE_SOLID, 3);
   SetIndexLabel(0, "Main Fast");
   SetIndexLabel(1, "Secondary Fast");
   SetIndexLabel(2, "Main Slow");
   SetIndexLabel(3, "Secondary Slow");
   IndicatorDigits (Digits);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int pos, counted_bars=IndicatorCounted();
   double fast, slow;
//----
   for (pos = 0; pos <= Bars - counted_bars - 1; pos ++)
     {
      fast = iMA (Symbol(),Period(), Fast_Period, 0 ,MODE_SMA, PRICE_CLOSE, pos);
      slow = iMA (Symbol(),Period(), Slow_Period, 0 ,MODE_SMA, PRICE_CLOSE, pos); 
      
      if (fast >= slow)
        {
        Secondary_Fast [pos] = fast;
        Main_Fast      [pos] = fast; // EMPTY_VALUE
        Secondary_Slow [pos] = slow;
        Main_Slow      [pos] = slow; // EMPTY_VALUE
        }
        else
        {
        Secondary_Fast [pos] = EMPTY_VALUE;
        Main_Fast      [pos] = fast;
        Secondary_Slow [pos] = EMPTY_VALUE;
        Main_Slow      [pos] = slow;
        }
     }
     
   if (Crossing_Alert_On_Bar > -1)
     {
     fast = Main_Fast [Crossing_Alert_On_Bar];
     slow = Main_Slow [Crossing_Alert_On_Bar];
     if (fast >= slow) // or slow <= fast
        {
        if (Alert_State != 1)
           {
           Alert (WindowExpertName()," Fast ",DoubleToStr (fast, Digits)," above Slow ",DoubleToStr (slow, Digits));
           Alert (WindowExpertName()," [",Fast_Period,">",Slow_Period,"] alert on bar ",Crossing_Alert_On_Bar);
           Alert_State = 1; 
           }
        }
        else // fast < slow or slow > fast
        {
        if (Alert_State != -1)
           {
           Alert (WindowExpertName()," Slow ", DoubleToStr (slow, Digits)," above Fast ",DoubleToStr (fast, Digits));
           Alert (WindowExpertName()," [",Slow_Period,">",Fast_Period,"] alert on bar ",Crossing_Alert_On_Bar);
           Alert_State = -1;
           }
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+

